public class Femme extends Humain {

	protected int fertilite;

	Femme(String nom) {
		this(0,0,nom,0);
	}

	Femme(int age, int poids, String nom, int fertilite) {
		super(age,poids,nom);
		this.fertilite = fertilite;
	}

    int getFertilite() {
        return fertilite;
    }
    void incFertilite(int inc) { fertilite += inc;}

	public void vieillir(Aging aging) {
		super.vieillir(aging);
		if (age == 15) {
			fertilite = loto.nextInt(101);
		}
	}

	// ajout d'un paramètre boolean afin d'éviter de grossir (cf. solution TP1 pour la régulation des naissances)
	public Humain rencontre (Humain h, boolean doGrowth, Breeding breeding) throws MeetingException {

		// stoppe directement si h est une instance de Femme
		if (h.isFemme() || h.isFille()) throw new BreedingForbiddenException(this, h);

		Humain bebe = null;
		int chance;
		int sexe;

		if ((age > 15) && (age < 50) && (h.getAge() > 15) && (poids < 150) && (h.getPoids() < 150)) {

			chance = loto.nextInt(101);

			if (chance < fertilite) {

				sexe = loto.nextInt(101);

				if (sexe < 50) {
					bebe = new Garcon("garcon"+nom+"-"+h.getNom());
				}
				else {
					bebe = new Fille("fille"+nom+"-"+h.getNom());
				}

				if (doGrowth) {
					breeding.gainWeight(h, this, 0);
				}
			}
            else {
                // comme c'est this le pb, on le met en premier paramètre
                throw new NoBreedingException(this, h);
            }
		}
		else {
		    throw new BreedingForbiddenException(this, h);
        }
		return bebe;
	}

	protected void setEsperanceVie() {
		// moyenne de 75, +/- 20
		esperanceVie = 75 + loto.nextInt(41) - 20;
	}

    // NB: d'un point de vue implémetnation, il est plus utile de définir ces émthodes dans Humain avec false comme retour => moins de code à écrire
    public boolean isHomme() {
        return false;
    }
    public boolean isFemme() {
        return true;
    }
    public boolean isGarcon() {
        return false;
    }
    public boolean isFille() {
        return false;
    }

	public void print() {
		System.out.println(nom+" : "+age+" ans, "+poids+" kg, mourra à "+esperanceVie+" ans, fertile à "+fertilite+"%");
	}

}
