public class Fille extends Femme {

    Fille(String nom) {
        this(0,0,nom,0);
    }

    Fille(int age, int poids, String nom, int fertilite) {
        super(age,poids,nom, fertilite);
    }

    /* Rq : cette méthode est la même que celle de Fille. Cela serait donc bien de pouvoir eviter cette copie
       en mettant le code dans une super-classe commune. Le problème est que cette classe est Humain.
       Or, a cause de super.rencontre(), Il est donc impossible de mettre cette méthode dans Humain.
       On est donc bien obligé de la copier/coller dans Garcon et Fille.
     */
    public Humain rencontre (Humain h, boolean doGrowth, Breeding breeding) throws MeetingException {
        // stoppe immédiatement si h pas adulte
        if (h.isGarcon() || h.isFille() ) throw new BreedingForbiddenException(this, h);
        // sinon on utilise la super méthode.
        Humain bebe = super.rencontre(h, doGrowth, breeding);
        return bebe;
    }

    // NB: d'un point de vue implémentation, il est plus utile de définir ces émthodes dans Humain avec false comme retour => moins de code à écrire
    public boolean isHomme() {
        return false;
    }
    public boolean isFemme() {
        return false;
    }
    public boolean isGarcon() {
        return false;
    }
    public boolean isFille() {
        return true;
    }

}
