public class Homme extends Humain {

	protected int batifolage;
	private int salaire; // la classe Garcon n'hérite pas de salaire.

	Homme(String nom) {
	    // exemple de la 3ème utilisation de this : le caînage de constructeurs
        // dans ce cas, on appelle le constrcteur jsute en dessous, qui lui-même appelle
        // le constructeur général.
	    this(0,0,nom,0);
	}

	Homme(int age, int poids, String nom, int batifolage) {
        this(age, poids, nom, age>=18?loto.nextInt(10000) + 1000:0, batifolage);
	}

    Homme(int age, int poids, String nom, int salaire, int batifolage) {
        super(age,poids,nom);
        this.salaire = salaire;
        this.batifolage = batifolage;
    }

    public int getBatifolage() {
        return batifolage;
    }

	public int getSalaire() {
		return salaire;
	}

	public void vieillir(Aging aging) {
		super.vieillir(aging);

		if (age >= 60) {
			batifolage = 50 + loto.nextInt(50);
		}
		else if (age >= 30) {
			batifolage = 20 + loto.nextInt(30);
		}
		else if (age >= 15) {
			batifolage = 70 + loto.nextInt(30);
		}
		if (age == 18) {
			salaire = loto.nextInt(10000) + 1000;
		}
	}

	// ajout d'un paramètre boolean afin d'éviter de grossir (cf. solution TP1 pour la régulation des naissances)
	public Humain rencontre (Humain h, boolean doGrowth, Breeding breeding) throws MeetingException {

		// stoppe directement si h est une instance d'homme
		if (h.isHomme() || h.isGarcon()) throw new BreedingForbiddenException(this, h);
		// sinon transtype h en femme
		Femme f =(Femme)h;

		Humain bebe = null;
		int chance;
		int sexe;

		chance = loto.nextInt(101);
        // comme c'est this le pb, on le met en premier paramètre
		if (chance <= batifolage) throw new NoBreedingException(this, h);

		if ((age > 15) && (f.getAge() > 15) && (f.getAge() < 50) && (poids < 150) && (f.getPoids() < 150)) {

			chance = loto.nextInt(101);

			if (chance < f.getFertilite()) {

				sexe = loto.nextInt(101);

				if (sexe < 50) {
					bebe = new Garcon("garcon"+nom+"-"+f.getNom());
				}
				else {
					bebe = new Fille("fille"+nom+"-"+f.getNom());
				}
				if (doGrowth) {
					breeding.gainWeight(this, h, 1);
				}
			}
			else {
			    // comme c'est h le pb, on le met en premier paramètre
			    throw new NoBreedingException(h, this);
            }
		}
        else {
            throw new BreedingForbiddenException(this, h);
        }
		return bebe;
	}

	protected void setEsperanceVie() {
		// moyenne de 65, +/- 15
		esperanceVie = 65 + loto.nextInt(31) - 15;
	}

	// NB: d'un point de vue implémetnation, il est plus utile de définir ces émthodes dans Humain avec false comme retour => moins de code à écrire
	public boolean isHomme() {
		return true;
	}
    public boolean isFemme() {
        return false;
    }
    public boolean isGarcon() {
        return false;
    }
    public boolean isFille() {
        return false;
    }

	public void print() {
		System.out.println(nom+" : "+age+" ans, "+poids+" kg, mourra à "+esperanceVie+" ans, gagne "+salaire+" euros");
	}

	public int compareTo(Humain h) {
		// utilise la comparaison générale sur l'âge
		int ret = super.compareTo(h);
		// si pas le même âge, la valeur reste la même
		if (ret != 0) return ret;
		// sinon, si h est une femme, on la met avant
		if (h.isFemme()) return 1;
		// sinon, on regarde le salaire
		Homme ho = (Homme)h;
		return salaire-ho.salaire;
	}
}
