import java.util.*;

class LifeGame {

    private int taillePopInit;
    private int nbTour;
    private boolean doAccident;
    private int controlType;
    private int nbBaby;
    private Population pop;
    private Population naissances;
    private Random loto;
    List<Integer> popId;
    private Humain[] couple;

    public LifeGame(int taillePopInit, int nbTour, boolean doAccident, int controlType, int nbBaby) {
        this.taillePopInit = taillePopInit;
        this.nbTour = nbTour;
        this.doAccident = doAccident;
        this.controlType = controlType;
        this.nbBaby = nbBaby;
        loto = new Random(taillePopInit+nbTour);
    }

    public void intialize() {

        pop = new Population();
        naissances = new Population();

        for (int i = 0; i < taillePopInit / 2; i++) {
            Homme h = new Homme(18, 70, "homme" + (i + 1), 80);
            pop.addHumain(h);
            int fertilite = loto.nextInt(101);
            Femme f = new Femme(18, 55, "femme" + (i + 1), fertilite);
            pop.addHumain(f);
        }
    }

    private void findCouples() {
        List<Integer> hId = new ArrayList<>();
        List<Integer> fId = new ArrayList<>();
        for(int i=0;i<pop.taille();i++) {
            Humain h = pop.getHumain(i);
            if (h.age > 15) {
                if (h.isHomme()) {
                    hId.add(i);
                }
                else {
                    fId.add(i);
                }
            }
        }
        int max = hId.size() < fId.size() ? hId.size() : fId.size();
        for(int i=0;i<max;i++) {
            popId.add(hId.get(i));
            popId.add(fId.get(i));
        }

        /* DEBUG
        for(int j=0;j<max;j++) {
            System.out.print(popId.get(2*j)+","+popId.get(2*j+1)+" ");
        }
        System.out.println();
         */
    }

    // retourne le nombre de décrémentation qui doit être appliqué sur le nombre de rencontre possibles
    private int manageAccidents(boolean teenagers, boolean baby) {

        int decEncounters = 0;

        // accident rencontre adolescent => 50% de chance de tuer un humain
        if (teenagers) {
            int kill = loto.nextInt(100);
            if (kill < 50) {
                System.out.print("2 adolescents provoquent un terrible accient :");
                if (killHuman()) decEncounters++;
            }
        }
        // accident post naissance => tue forcément un humain
        if (baby) {
            System.out.print("Sur la route de la maternité, 2 personnes provoquent un terrible accident :");
            if (killHuman()) decEncounters++;
        }
        return decEncounters;
    }

    private boolean killHuman() {
        boolean lessEncounters = false;
        int id = loto.nextInt(pop.taille() + naissances.taille());
        //mort d'un bebe
        if (id >= pop.taille()) {
            id -= pop.taille();
            Humain dead = naissances.removeHumain(id);
            System.out.println(dead.nom + " [ at " + id + " in naissance ] est mort-né");
        } else {
            Humain dead = pop.removeHumain(id);
            // on doit aussi modifier popId si l'indice de cet humain s'y trouve
            // En effet, si un Humain mort est à l'indice id = 10, cela veut dire que ceux qui sont en 11, 12, ...
            // vont ensuite être à l'indice 10, 11, ... Il faut donc décrémenter toutes les valeurs dans popId > 10.
            int index = popId.indexOf(id);
            System.out.println(dead.nom + " [ at " + id + " in pop ] [ at " + index + " in popId ] est mort");
            // si l'indice de lh'umain est présent dans popId, modifier popId
            if (index != -1) {
                if (controlType == 0) {
                    popId.remove(index);
                } else {
                    // si controlType = 1 | 2, popId contient en alternance des index d'Homme et de Femme
                    // si on enlève un Homme, il faut enlever la femme juste, et si c'est une femme, il faut
                    // enlever l'homme avant. Donc il suffit de diminuer index de 1
                    if (index % 2 == 1) {
                        index--;
                    }
                    popId.remove(index); // on enlève l'homme
                    popId.remove(index); // on refait pour enlever la femme
                    lessEncounters = true; // il y a forcément une rencontre possible de moins

                }
            }
            // décrémentation de 1 des valeurs > id
            for (int k = 0; k < popId.size(); k++) {
                int val = popId.get(k);
                if (val > id) {
                    popId.set(k, val - 1);
                }
            }
        }
        return lessEncounters;
    }

    private void setCouple(int tourJeu) {
        Humain h1,h2;

        // a cause des accidents, popId peut diminuer. Il est donc possible que sa taille devienne
        // <2 alors que nbRencontre n'est pas atteint. Dans ce cas, pas de couple
        if (popId.size() < 2) {
            couple = null;
            return;
        }

        if (controlType == 0) {
            int id1 = loto.nextInt(popId.size());
            int index1 = popId.remove(id1);
            // Rq : le fait d'enlever id1 empêche de retomber dessus.
            int id2 = loto.nextInt(popId.size());
            int index2 = popId.remove(id2);

            h1 = pop.getHumain(index1);
            h2 = pop.getHumain(index2);
        } else {
            int index1 = popId.get(2 * tourJeu);
            int index2 = popId.get(2 * tourJeu + 1);
            h1 = pop.getHumain(index1);
            h2 = pop.getHumain(index2);
        }
        Humain[] tab = {h1, h2};
        couple = tab;
    }

    public void start() {

        popId = new ArrayList<>();
        int nbRencontre = 0;
        Homme h = null;
        Femme f = null;
        Humain bebe = null;

        boolean doGrowth = true;

        for(int i=0;i<nbTour;i++) {

            System.out.println("tour "+i+":");
            if (pop.taille() == 0) {
                System.out.println("tout le monde est mort. Arret du jeu");
                System.exit(0);
            }

            // mise en palce du tour
            naissances.vider();
            popId.clear();
            // controle pop. = 0 : création d'une liste d'index allant de 0 à taille population-1
            if (controlType == 0) {
                for(int j=0;j<pop.taille();j++) {
                    popId.add(j);
                }
                if (pop.taille() >= 2) {
                    nbRencontre = loto.nextInt(pop.taille()/2);
                }
                else {
                    nbRencontre = 0;
                }
            }
            // controle pop. = 1 ou 2 : trouver tous les couples possibles.
            else if ((controlType == 1) || (controlType == 2)) {
                findCouples();
                nbRencontre = popId.size()/2;
            }

            // debut du tour de jeu
            int nbLoop = 1;
            for(int j=0;j<nbRencontre;j++) {

                // tirage du couple
                setCouple(j);
                // si pas de couple possible, on arrête la boucle
                if (couple == null) break;
                try {
                    bebe = pop.rencontre(couple[0],couple[1], doGrowth, (ho, fe, type) -> {
                        if (type == 0) {
                            fe.grossir(10);
                            ho.grossir(loto.nextInt(21));
                        } else {
                            ho.grossir(loto.nextInt(21) - 10);
                            fe.grossir(10);
                        }
                    });
                    // on est sur que bebe != null, sinon il y a une exception
                    naissances.addHumain(bebe);
                    System.out.print(":-) naissance de : ");
                    bebe.print();
                }
                catch(MeetingException e) {
                    System.out.println(e.getMessage());
                }

                if (doAccident) {
                    boolean teenagers = false;
                    if ( ((couple[0].isGarcon() && couple[1].isFille())) || ((couple[1].isGarcon() && couple[0].isFille())) ) teenagers = true;
                    int dec = manageAccidents(teenagers, bebe == null?false:true);
                    nbRencontre -= dec;
                        /* DEBUG
                        for(int k=0;k<nbRencontre;k++) {
                            System.out.print(popId.get(2*k)+","+popId.get(2*k+1)+" ");
                        }
                        System.out.println();

                         */
                }

                // regulation population
                if (controlType == 2) {
                    // si bon nombre de bébés => stop
                    if (naissances.taille() == nbBaby) {
                        System.out.println("nombre de bebe atteint. Il a fallu " + nbLoop + " boucles pour créer " + nbBaby + " bebes");
                        break; // stoppe la boucle
                    }
                    // sinon, si fin de boucle => nouvelle boucle
                    else if (j >= nbRencontre - 1) {
                        popId.clear();
                        findCouples();
                        nbRencontre = popId.size() / 2;
                        j = -1; // pour réinitialiser la boucle j
                        nbLoop++;
                        doGrowth = false; // pour éviter que les humains grossissent de nouveau, sinon la population devient obese et meurt :-)
                    }
                }
            }

            pop.addPopulation(naissances);

            // le paramètre change le type de tri (cf. Population)
            /*
            pop.trier(Population.SORT_AGE_INC_SEX_ATTR);
            System.out.println("population actuelle : ");
            pop.print();


             */
            pop.vieillir(hu -> {
                if ((hu.isHomme() || (hu.isGarcon()))) {
                    if (hu.getAge() <= 20) hu.setPoids(3+(int)(3.6*hu.getAge()));
                }
                else {
                    if (hu.getAge() <= 20) hu.setPoids(3+(int)(2.6*hu.getAge()));
                    // on est sur que c'est une femme/fille => on modifie ici la fertilité
                    if ((pop.taille() > 20) && (pop.taille() <= 50)) {
                        ((Femme)hu).incFertilite(2);
                    }
                    else if (pop.taille() > 50) {
                        ((Femme)hu).incFertilite(-1);
                    }
                }
                if (hu.getAge() >= 50) hu.grossir(hu.getAge() % 2);
            });
        }
        System.out.println("population finale : " + pop.taille());
    }
}
