import java.util.*;

class Population {


	public final static int SORT_AGE_DEC = 0;
	public final static int SORT_SEX = 1;
	public final static int SORT_AGE_INC_SEX = 2;
	public final static int SORT_SEX_AGE_INC = 3;
	public final static int SORT_AGE_INC_SEX_ATTR = 4;

	private ArrayList<Humain> pop;

	Population() {
		pop = new ArrayList<Humain>();
	}

	public ArrayList<Humain> getPop() {
		return pop;
	}

	public void vider() {
		pop.clear();
	}

	public void addPopulation(Population p) {
		pop.addAll(p.pop);
	}

	public Humain getHumain(int index) {
		return pop.get(index);
	}

	public void addHumain(Humain h) {
		pop.add(h);
	}

	public Humain removeHumain(Humain h) {

		boolean ok = pop.remove(h);
		if (ok) return h;
		return null;
	}

	public Humain removeHumain(int index) {
		return pop.remove(index);
	}

	public int taille() {
		return pop.size();
	}

	public void vieillir(Aging aging) {

	    // Rq : en utilisant un ListIterator (au lieu d'un simple Iterator, on est sur que l'on
        // peut ajouter un individu sans que cela plante.
		ListIterator<Humain> it = pop.listIterator();
		Humain h;

		while (it.hasNext()) {
			h = it.next();
			h.vieillir(aging);
			// test passage adulte
            if (h.getAge() == 18) {
                Humain newOne = null;
                String name = h.getNom();
                if (h.isGarcon()) {
                    name = name.replaceFirst("garcon", "homme");
                    newOne = new Homme(h.getAge(), h.getPoids(), name, ((Garcon)h).getBatifolage());
                }
                else {
                    name = name.replaceFirst("fille", "femme");
                    newOne = new Femme(h.getAge(), h.getPoids(), name, ((Fille)h).getFertilite());
                }
                it.remove();
                it.add(newOne);
            }
			// test de fin de vie
			if (h.isDead() == true) {
				System.out.print("  :-( mort de :");
				h.print();
				// suppression de l'humain
				it.remove();
			}
		}
	}

	public Humain rencontre(Humain h1, Humain h2, boolean doGrowth, Breeding breeding) throws MeetingException{
        return h1.rencontre(h2, doGrowth, breeding);
    }

	public void print() {

		for(Humain h : pop) {
			h.print();
		}
	}

	public void trier(int type) {
	    if (type == 0) trierAgeDecroissant();
	    else if (type == 1) trierSexe();
        else if (type == 2) trierAgeCroissantSexe();
        else if (type == 3) trierSexeAgeCroissant();
		else if (type == 4) trierAgeCroissantSexeAttrs();
    }
	public void trierAgeDecroissant() {
		Collections.sort(pop, (h1, h2) -> h2.getAge() - h1.getAge());
	}

    public void trierSexe() {
        Collections.sort(pop, (h1, h2) -> {
            int s1 = 0;
            int s2 = 0;
            if (h1.isHomme() || h1.isGarcon()) s1 = 1;
            if (h2.isHomme() || h2.isGarcon()) s2 = 1;
            return s1-s2;
        });
    }

    public void trierAgeCroissantSexe() {
        Collections.sort(pop, (h1, h2) -> {
            int s1 = 0;
            int s2 = 0;
            if (h1.getAge() < h2.getAge()) return -1;
            else if (h1.getAge() > h2.getAge()) return 1;
            else {
                if (h1.isHomme() || h1.isGarcon()) s1 = 1;
                if (h2.isHomme() || h2.isGarcon()) s2 = 1;
                return s1 - s2;
            }
        });
    }

    public void trierSexeAgeCroissant() {
        Collections.sort(pop, (h1, h2) -> {
            int s1 = 0;
            int s2 = 0;
            if (h1.isHomme() || h1.isGarcon()) s1 = 1;
            if (h2.isHomme() || h2.isGarcon()) s2 = 1;
            if (s1 == s2) {
                if (h1.getAge() < h2.getAge()) return -1;
                else if (h1.getAge() > h2.getAge()) return 1;
                else return 0;
            }
            return s1 - s2;
        });
    }

	public void trierAgeCroissantSexeAttrs() {
		Collections.sort(pop, (h1, h2) -> {
			int s1 = 0;
			int s2 = 0;
			if (h1.getAge() < h2.getAge()) return -1;
			else if (h1.getAge() > h2.getAge()) return 1;
			else {
				if (h1.isHomme() || h1.isGarcon()) s1 = 1;
				if (h2.isHomme() || h2.isGarcon()) s2 = 1;
				if (s1 == s2) {
					if (s1 == 0) {
						return ((Femme)h1).getFertilite() - ((Femme)h2).getFertilite();
					}
					else {
						return ((Homme)h1).getSalaire() - ((Homme)h2).getSalaire();
					}
				}
				return s1 - s2;
			}
		});
	}

}
